/* __placeholder__ */
import { ref } from 'vue';
import { useFormWidget } from './FormWidget';
import { useConfig } from '../config';
const { defineProps, defineSlots, defineEmits, defineExpose, defineModel, defineOptions, withDefaults, } = await import('vue');
let __VLS_typeProps;
const props = withDefaults(defineProps(), useConfig('BooleanWidget', {
    empty: 'N/A',
    trueVal: 'Y',
    falseVal: 'N',
}));
const inputEl = ref();
const { value, schema, isRequired, setValue, register, validatedMeta, validator: defaultValidator, validate, view, isValid, } = useFormWidget('BooleanWidget', props);
const validator = () => {
    let el = inputEl.value;
    defaultValidator();
    if (el) {
        validatedMeta.value.validity = el.checkValidity();
        if (el.validationMessage)
            validatedMeta.value.err ??= [{ msg: el.validationMessage }];
    }
    return validatedMeta.value;
};
register({ validator, el: inputEl });
const inputHandler = (e) => {
    if (e.target instanceof HTMLInputElement) {
        setValue(e.target.checked);
        validate();
    }
};
if (value.value == null)
    setValue(schema.value.defaultValue ?? false);
const __VLS_withDefaultsArg = (function (t) { return t; })(useConfig('BooleanWidget', {
    empty: 'N/A',
    trueVal: 'Y',
    falseVal: 'N',
}));
const __VLS_fnComponent = (await import('vue')).defineComponent({});
let __VLS_functionalComponentProps;
function __VLS_template() {
    let __VLS_ctx;
    /* Components */
    let __VLS_otherComponents;
    let __VLS_own;
    let __VLS_localComponents;
    let __VLS_components;
    let __VLS_styleScopedClasses;
    let __VLS_resolvedLocalAndGlobalComponents;
    if (__VLS_ctx.view) {
        (__VLS_ctx.value ?? __VLS_ctx.empty);
        // @ts-ignore
        [view, value, empty,];
    }
    else {
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ("cfb-grid") }, });
        __VLS_elementAsFunction(__VLS_intrinsicElements.button, __VLS_intrinsicElements.button)({ ...{ onClick: (...[$event]) => {
                    if (!(!((__VLS_ctx.view))))
                        return;
                    if (!__VLS_ctx.view)
                        __VLS_ctx.inputEl.click();
                    ;
                    // @ts-ignore
                    [view, inputEl,];
                } }, type: ("button"), ...{ class: (([
                    'cfb-w-14 cfb-mb-2 cfb-h-7 cfb-rounded-3xl cfb-relative cfb-cursor-pointer',
                    {
                        'cfb-bg-valid-400 hover:cfb-bg-valid-500': __VLS_ctx.value == true,
                        'cfb-bg-danger-100 hover:cfb-bg-danger-200': __VLS_ctx.isValid() == false,
                        'cfb-bg-gray-200 hover:cfb-bg-gray-300': __VLS_ctx.isValid() == undefined,
                    },
                ])) }, });
        __VLS_styleScopedClasses = ([
            'cfb-w-14 cfb-mb-2 cfb-h-7 cfb-rounded-3xl cfb-relative cfb-cursor-pointer',
            {
                'cfb-bg-valid-400 hover:cfb-bg-valid-500': value == true,
                'cfb-bg-danger-100 hover:cfb-bg-danger-200': isValid() == false,
                'cfb-bg-gray-200 hover:cfb-bg-gray-300': isValid() == undefined,
            },
        ]);
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: (([
                    'cfb-grid cfb-items-center cfb-h-full cfb-top-0 cfb-absolute cfb-px-1 cfb-transition-all',
                    __VLS_ctx.value ? 'cfb-left-[calc(100%-1.7rem)]' : 'cfb-left-0',
                ])) }, });
        __VLS_styleScopedClasses = ([
            'cfb-grid cfb-items-center cfb-h-full cfb-top-0 cfb-absolute cfb-px-1 cfb-transition-all',
            value ? 'cfb-left-[calc(100%-1.7rem)]' : 'cfb-left-0',
        ]);
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ("cfb-w-5 cfb-h-5 cfb-shadow cfb-bg-white cfb-rounded-3xl") }, });
        // @ts-ignore
        [value, value, isValid, isValid,];
        __VLS_elementAsFunction(__VLS_intrinsicElements.input)({ ...{ onChange: (__VLS_ctx.inputHandler) }, ref: ("inputEl"), ...{ class: ("cfb-hidden") }, type: ("checkbox"), required: ((__VLS_ctx.isRequired())), checked: ((__VLS_ctx.value)), id: ((__VLS_ctx.widgetId ?? __VLS_ctx.path)), });
        // @ts-ignore
        (__VLS_ctx.inputEl);
        // @ts-ignore
        [value, inputEl, inputHandler, isRequired, widgetId, path,];
        if (__VLS_ctx.validatedMeta?.err?.[0].msg) {
            __VLS_elementAsFunction(__VLS_intrinsicElements.span, __VLS_intrinsicElements.span)({ ...{ class: ("cfb-mt-1 cfb-text-sm cfb-text-danger-600") }, });
            (__VLS_ctx.validatedMeta.err[0].msg);
            // @ts-ignore
            [validatedMeta, validatedMeta,];
        }
    }
    if (typeof __VLS_styleScopedClasses === 'object' && !Array.isArray(__VLS_styleScopedClasses)) {
        __VLS_styleScopedClasses['cfb-grid'];
        __VLS_styleScopedClasses['cfb-w-5'];
        __VLS_styleScopedClasses['cfb-h-5'];
        __VLS_styleScopedClasses['cfb-shadow'];
        __VLS_styleScopedClasses['cfb-bg-white'];
        __VLS_styleScopedClasses['cfb-rounded-3xl'];
        __VLS_styleScopedClasses['cfb-hidden'];
        __VLS_styleScopedClasses['cfb-mt-1'];
        __VLS_styleScopedClasses['cfb-text-sm'];
        __VLS_styleScopedClasses['cfb-text-danger-600'];
    }
    var __VLS_slots;
    return __VLS_slots;
    const __VLS_componentsOption = {};
    let __VLS_name;
    let __VLS_defineComponent;
    const __VLS_internalComponent = __VLS_defineComponent({
        setup() {
            return {
                inputEl: inputEl,
                value: value,
                isRequired: isRequired,
                validatedMeta: validatedMeta,
                view: view,
                isValid: isValid,
                inputHandler: inputHandler,
            };
        },
        props: {},
    });
}
export default (await import('vue')).defineComponent({
    setup() {
        return {};
    },
    props: {},
});
;
