/* __placeholder__ */
import { get } from '@codeperate/utils';
import { ref } from 'vue';
import { columnClass } from '../utils/columns.utils';
import { useFormWidget } from './FormWidget';
import { useConfig } from '../config';
const { defineProps, defineSlots, defineEmits, defineExpose, defineModel, defineOptions, withDefaults, } = await import('vue');
let __VLS_typeProps;
const props = withDefaults(defineProps(), useConfig('ObjectWidget', {
    removeAdditionalProperties: true,
    reserveKey: () => [],
    testIdPrefix: 'form',
}));
const { register, getPath, getSchema, form } = useFormWidget('ObjectWidget', props);
const onExportValue = async (obj, options) => {
    const reserveKey = props.reserveKey;
    if (options.removeAdditional && props.removeAdditionalProperties) {
        const currentObj = get(obj, `value.${getPath()}`);
        if (currentObj && currentObj instanceof Object) {
            for (let key in getSchema().properties) {
                const property = getSchema().properties?.[key];
                if (property?.hidden) {
                    const isHidden = typeof property.hidden == 'function' ? property.hidden(fw) : property.hidden;
                    if (isHidden)
                        continue;
                }
                reserveKey.push(key.split('.')[0]);
            }
            for (let key in currentObj) {
                if (reserveKey.includes(key))
                    continue;
                delete currentObj[key];
            }
        }
    }
};
const el = ref();
const fw = register({ el, onExportValue });
const { schema } = fw;
if (!schema.value.properties)
    throw new Error('ObjectWidget must have properties');
// onRenderTriggered(({ key, target, type }) => {
//     console.log(`Render triggered on component`, { key, target, type });
// });
const componentProps = key => {
    let _props = schema.value.properties?.[key]['props'] ?? {};
    return typeof _props == 'function' ? _props({ form }) : _props;
};
const joinPath = (path, key) => {
    return [...path.split('.').filter(s => s), key].join('.');
};
const testId = (path, key) => {
    return `${props.testIdPrefix}:${joinPath(path, key)}`;
};
const __VLS_withDefaultsArg = (function (t) { return t; })(useConfig('ObjectWidget', {
    removeAdditionalProperties: true,
    reserveKey: () => [],
    testIdPrefix: 'form',
}));
const __VLS_fnComponent = (await import('vue')).defineComponent({});
let __VLS_functionalComponentProps;
function __VLS_template() {
    let __VLS_ctx;
    /* Components */
    let __VLS_otherComponents;
    let __VLS_own;
    let __VLS_localComponents;
    let __VLS_components;
    let __VLS_styleScopedClasses;
    let __VLS_resolvedLocalAndGlobalComponents;
    __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ("cfb-grid des:cfb-grid-cols-12 mob:cfb-grid-cols-6 cfb-gap-4") }, ref: ("el"), });
    // @ts-ignore
    (__VLS_ctx.el);
    for (const [{ widget, label, hidden, columns, required }, key] of __VLS_getVForSourceType((__VLS_ctx.schema.properties))) {
        (key);
        if (!(typeof hidden == 'function' ? hidden(__VLS_ctx.fw) : hidden)) {
            __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ((['cfb-grid cfb-content-start', __VLS_ctx.columnClass(columns ?? widget.columns ?? 6)])) }, "data-testid": ((__VLS_ctx.testId(__VLS_ctx.path, key))), });
            __VLS_styleScopedClasses = (['cfb-grid cfb-content-start', columnClass(columns ?? widget.columns ?? 6)]);
            if (label != false) {
                __VLS_elementAsFunction(__VLS_intrinsicElements.label, __VLS_intrinsicElements.label)({ ...{ class: ("cfb-font-bold") }, });
                __VLS_elementAsFunction(__VLS_intrinsicElements.span, __VLS_intrinsicElements.span)({});
                __VLS_directiveFunction(__VLS_ctx.vHtml)((label ?? key));
                // @ts-ignore
                [el, schema, fw, columnClass, testId, path, vHtml,];
                if (typeof required == 'function' ? required(__VLS_ctx.fw) : required) {
                    __VLS_elementAsFunction(__VLS_intrinsicElements.span, __VLS_intrinsicElements.span)({ ...{ class: ("cfb-text-danger-600") }, });
                    // @ts-ignore
                    [fw,];
                }
            }
            const __VLS_0 = (widget.component);
            // @ts-ignore
            const __VLS_1 = __VLS_asFunctionalComponent(__VLS_0, new __VLS_0({ path: ((__VLS_ctx.joinPath(__VLS_ctx.path, key))), ...(__VLS_ctx.componentProps(key)), }));
            const __VLS_2 = __VLS_1({ path: ((__VLS_ctx.joinPath(__VLS_ctx.path, key))), ...(__VLS_ctx.componentProps(key)), }, ...__VLS_functionalComponentArgsRest(__VLS_1));
            ({}({ path: ((__VLS_ctx.joinPath(__VLS_ctx.path, key))), ...(__VLS_ctx.componentProps(key)), }));
            // @ts-ignore
            [path, joinPath, componentProps,];
            const __VLS_5 = __VLS_pickFunctionalComponentCtx(__VLS_0, __VLS_2);
        }
    }
    if (typeof __VLS_styleScopedClasses === 'object' && !Array.isArray(__VLS_styleScopedClasses)) {
        __VLS_styleScopedClasses['cfb-grid'];
        __VLS_styleScopedClasses['des:cfb-grid-cols-12'];
        __VLS_styleScopedClasses['mob:cfb-grid-cols-6'];
        __VLS_styleScopedClasses['cfb-gap-4'];
        __VLS_styleScopedClasses['cfb-font-bold'];
        __VLS_styleScopedClasses['cfb-text-danger-600'];
    }
    var __VLS_slots;
    return __VLS_slots;
    const __VLS_componentsOption = {};
    let __VLS_name;
    let __VLS_defineComponent;
    const __VLS_internalComponent = __VLS_defineComponent({
        setup() {
            return {
                columnClass: columnClass,
                el: el,
                fw: fw,
                schema: schema,
                componentProps: componentProps,
                joinPath: joinPath,
                testId: testId,
            };
        },
        props: {},
    });
}
export default (await import('vue')).defineComponent({
    setup() {
        return {};
    },
    props: {},
});
;
